/*
 * UI.h
 *
 *  Created on: May 5, 2018
 *      Author: Yunyang
 */

#ifndef UI_H_
#define UI_H_
#include <opencv2/opencv.hpp>
#include "UIListener.hpp"
#include "string"
#include <memory>

class UI {
	bool debug = false, showSlider = false;
	unsigned lastDebugFrame = 0;
	unsigned debugFrame = 0;
	std::shared_ptr<int> lastKey;
	int  width = 0, height = 0;
	unsigned state = 0;
	std::vector<cv::Mat> frames = {cv::Mat()};
	cv::Mat frame;
	cv::Mat originalFrame;

public:
	static const std::string NORMAL_WINDOW;
	static const std::string DEBUG_WINDOW;

	std::vector<UIListener *> UIListeners;
	UI(std::shared_ptr<int> lastKey);
	void render();
	void nextDebugFrame();
	cv::Mat* nextFrame();
	cv::Mat* currentFrame(int offset = 0);

	void setOriginalFrame(cv::Mat frame);
	cv::Mat* drawnFrame();
	cv::Mat getOriginalFrame() const;

	int getWidth() const;
	int getHeight() const;
	virtual ~UI();
};

#endif /* UI_H_ */
